-----------------------------------------------------------------------------------------------
--
--   Simplified T-Latch
--   Eirik Taylor, 04.06.2022
--   
--   
--   No T input, always toggling. Resetable to Q low, NQ high
--
-----------------------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity t_latch is
port (
		rst	: in STD_LOGIC;
		clk	: in STD_LOGIC;
		Q		: out STD_LOGIC;
		nQ		: out STD_LOGIC
	);
end t_latch;

architecture Behavioral of t_latch is

	signal state: std_logic;

begin

	toggleProcess : process (clk, rst)
	begin
		if (rst = '0') then 
			state <= '0'; 
		elsif (rising_edge(clk)) then 
			state<= not (state);
		end if;
	end process;

	Q <= state;
	nQ <= not state;

end Behavioral;
